const http = require('http')
const fs = require('fs')
const express = require('express');
var bodyParser = require('body-parser');
var events = require('events');

var WebSocketClient = require('websocket').client;
const { stringify } = require('qs');
const { resolve } = require('path');
//above are node modules that will need to be installed. "npm install http", etc

url = 'ws://192.168.1.138/ws/a';
var wscli = null;
var client = new WebSocketClient();
var inp = [0, 0, 0];
var posX = 0;
var posY = 0;
var stop = 0;
var orient = 0;
var oldL = 0;
var oldR = 0;
var L = 0;
var R = 0;
var degMod = 3.553

var inUse = false;
var queue = false;

var srv = express();
srv.use(express.static(__dirname + '/../'));

srv.use(express.urlencoded(
  {extended: true}
  ));
srv.use(express.text());
var jsonParser = express.json()
 
// create application/x-www-form-urlencoded parser
var urlencodedParser = bodyParser.urlencoded({ extended: false })

//Handle Websocket in/out Data
//Bot sends server update of wheel ticks multiple times a second
client.on('connect', (conn) => {
    console.log('WebSocket client connected');
    wscli = conn;
    conn.on('error', (err) => console.log(`connection error: ${err.toString()}`));
    conn.on('close', function() {
      console.log('Connection Closed');
    });
    conn.on('message', (msg) => {
      if (msg.type === 'utf8') {
        inp = msg.utf8Data.split(':');// Format of read Data: stopBit:Lticks:Rticks
        L = inp[1] - oldL; //L becomes the number of ticks read in for the left wheel that havnt already been accounted for
        R = inp[2] - oldR; //R becomes the number of ticks read in for the right wheel that havnt already been accounted for
        //console.log('Stop: ' + inp[0]);
        //console.log('L Dist: ' + L * 3.25 + 'mm');
        //console.log('R Dist: ' + R * 3.25 + 'mm');
        oldL = inp[1];
        oldR = inp[2];

        stop = inp[0];
        //posX = inp[1] * 3.25;

        if((L > 0 && R > 0) || (L < 0 && R < 0)){
          //forward move
          posY += Math.sin(orient * (Math.PI / 180)) * L * 3.25;
          posX += Math.cos(orient * (Math.PI / 180)) * L * 3.25;
        }

        if(L < 0 && R > 0){
          //Left Turn
          console.log(R);
          orient -= R * degMod;
        }

        if(L > 0 && R < 0){
          //Right Turn
          orient += L * degMod;
        }

        //Correct orientation if not within 0 - 360 degrees
        if(orient < 0)
          orient += 360;
        if(orient > 360)
          orient -= 360;

        //console.log("=======================");
        //console.log("X: " + posX);
        //console.log("Y: " + posY);
        //console.log("O: " + orient);
      }
    });
  });
  client.on('connectFailed', (err) => console.log(`connection failed: ${err.toString()}`));
  client.connect('ws://192.168.1.138/ws/a');

//Server Routes
//Index get/post
srv.get('/', (req, res) => {
  res.sendFile('/index.html');
});

srv.post('/', (req, res) => {
  if(!inUse){
    const usertimeout = connected(inUse);
    const timeout = Promise.all([usertimeout]);
    //inUse = true;
    if(req.body.nav == "D"){
      res.redirect('/dircontrol.html');
    }
  
    if(req.body.nav == "A"){
      res.redirect('/autcontrol.html');
    }
  }
  else if(inUse && !queue){//Send users to Queue pages
    const usertimeout = connected(queue);
    const timeout = Promise.all([usertimeout]);
    queue = true;
    if(req.body.nav == "D"){
      res.redirect('/dirqueue.html');
    }
  
    if(req.body.nav == "A"){
      res.redirect('/autqueue.html');
    }
  }
    else{
      console.log("Bot already in use!");
    }
});

//Autonomous Control get/post
srv.get('/autcontrol', (req, res) => {
  res.sendFile(__dirname + ('autcontrol.html'));
});

srv.post('/autcontrol', jsonParser, (req, res) => {
  if (wscli === null) {
    console.log('posted, no connection established');
    res.status(500);
  } else {
  const navResult = goto(req.body.xcoord, req.body.ycoord);
  const gotoResult = Promise.all([navResult]);

  res.status(200);
  }
});

//Direct Control get/post
srv.get('/dircontrol', (req, res) => {
  res.sendFile(__dirname + ('dircontrol.html'));
});

srv.post('/dircontrol', jsonParser, (req, res) => {
  console.log("user: " + req.socket.remoteAddress);
  if (wscli === null) {
    console.log('posted, no connection established');
    res.status(500);
  } else {
    console.log("Web Input: " + req.body.nav);

    if(req.body.nav[0] == "E"){
      wscli.send(req.body.nav);
    }

    else
      wscli.send(req.body.nav + "050");
    res.status(200);
  }
});
srv.listen(process.env.PORT || 3000);

//goto function is head of Autonomous mode. given x,y coord destination, calculates turn angle and total distance needed to get to destination
async function goto(x, y){
/*
      Position Grid
    |
  x |
    |
    |
    0———————————
              Y
*/
console.log("Destination: " + x + ", " + y);
  var dispX = x - posX; // X displacement needed to get to x
  var dispY = y - posY; // Y displacement needed to get to y
  var d = Math.sqrt(Math.pow(dispX, 2) + Math.pow(dispY, 2));
  var theta = Math.asin(dispY / d) * (180 / Math.PI); //angle bot needs to be from x axis
  console.log("Raw Desired Orientation: " + theta);
  if(dispX < 0 && dispY > 0){ //Quad 2
    theta = 180 - theta;
    if(theta < -180)
      theta += 360;
  theta = orient - theta;
  }

  else if(dispX < 0 && dispY < 0){ //Quad 1
    theta = Math.abs(theta - 180);
    console.log("Adjusted Desired Orientation: " + theta);
    theta -= orient;

    if(theta < -180)
      theta += 360;
    if(theta > 180)
      theta -= 360;
  }
  //console.log("Adjusted Desired Orientation: " + theta);
  //theta -= orient; //degrees bot needs to rotate
  //theta = Math.abs(orient - theta);
  else{
    if(dispY >= 0){ //Quad 3
      theta -= orient;
    }
    else{ //Quad 4 theta will be negative
      theta = 360 + theta;
      theta -= orient;
    }
    if(theta < -180)
      theta += 360;
    if(theta > 180)
      theta -= 360;
  }

  console.log("Distance calculated: " + d);
  console.log("Current Orientation: " + orient);
  console.log("Orientation adjustment calculated: " + theta);
  if (!(await move(d, theta))) {
    console.log('move failed!');
    wscli.send("S050");
    if (!(await redirect()))
    {
      return;
    }
  }

  dispX = x - posX; // X displacement needed to get to x
  dispY = y - posY; // Y displacement needed to get to y
  d = Math.sqrt(Math.pow(dispX, 2) + Math.pow(dispY, 2));

  if(d > 90)
    await goto(x, y);

  console.log("Current Position: " + posX + ", " + posY);
  console.log("Destination: " + x + ", " + y);

  wscli.send("S000");
}

//Move handles basic moves. Given distance and degrees to turn. Returns false if there is an obstacle, true if dest reached or overshoot
async function move(dist, ori){
  var destO = orient + ori;
  
  if(destO < 0)
    destO += 360;
  if(destO >= 360)
    destO -= 360;

  var destX = posX + (cosine(destO) * dist);
  var destY = posY + (sine(destO) * dist);
  console.log("Current Position: " + posX + ", " + posY + ", " + orient);
  console.log("Destination: " + destX + ", " + destY + ", " + destO);
  
  //adjust orientation first
  while(orient > destO + 5 || orient < destO - 5){
    //console.log("Current Orientation: " + orient);
    //console.log("Desired Orientation: " + destO);
    if(ori < 0)
      wscli.send("L020");
    else
      wscli.send("R020");
    await sleep(200);
  }

  //Now move distance
  while(posX > 10 + destX || posX < destX - 10 || posY > 10 + destY || posY < destY - 10)
  {
    //console.log("Current Position: " + posX + ", " + posY + ", " + orient);
    //console.log("Destination: " + destX + ", " + destY + ", " + destO);
    dist = Math.sqrt(Math.pow((destX - posX), 2) + Math.pow((destY - posY), 2));
    //console.log("Distance from target: " + dist);
    
    wscli.send("F050");
    await sleep(100);

    if(stop == 1){
        //obstacle in the way
        console.log("Interrupted! Returning.");
        return false;
      }
    
    if(dist < Math.sqrt(Math.pow((destX - posX), 2) + Math.pow((destY - posY), 2))){
      //Overshoot
      console.log("Overshoot!");
      return true;
    }
  }

  console.log("Destination Reached!");
  wscli.send("S050");
  return true;
}

//Redirect is called if hardware notifies obstacle ahead. returns true if sucessful, false if not
async function redirect(){
  console.log("Obstacle Detected!");
  //Check if right is clear
  await move(0, 90);
  await sleep(300);
  if(stop == 0){
    await move(500, 0);
    await move(0, -90);
    await move(500, 0);
    return true;
  }
  else{
    await move(180);
    await sleep(300);
    if(stop == 0){
      await move(500, 0);
      await move(0, 90);
      await move(500, 0);
      return true;
    }
    return false;
  }
}

function sleep(ms) {
  return new Promise(resolve => setTimeout(resolve, ms));
}

//rewritten math functions to handle degrees

function sine(theta){
  radT = theta * (Math.PI / 180);
  return Math.sin(radT);
}

function cosine(theta){
  radT = theta * (Math.PI / 180);
  return Math.cos(radT);
}

async function connected(timed){
  await sleep(120000);
  timed = false;
  return;
}